﻿Imports System.Windows
Imports System.Windows.Controls

Namespace OrientingMap
	Partial Public Class MapTile
		Inherits UserControl
'INSTANT VB NOTE: The variable quadKey was renamed since Visual Basic does not allow class members with the same name:
		Private quadKey_Renamed As QuadKey

		Public Sub New()
			InitializeComponent()
		End Sub

		Public Property QuadKey As QuadKey
			Set(ByVal value As QuadKey)
				quadKey_Renamed = value

				If quadKey_Renamed IsNot Nothing Then
					' Debugging purposes
					txtblk.Text = quadKey_Renamed.ToString()

					Refresh()
				Else
                    bitmapImage1.UriSource = Nothing
				End If
			End Set
			Get
				Return quadKey_Renamed
			End Get
		End Property

		Public WriteOnly Property ImageOpened As EventHandler(Of RoutedEventArgs)
			Set(ByVal value As EventHandler(Of RoutedEventArgs))
				If value IsNot Nothing Then
                    AddHandler bitmapImage1.ImageOpened, value
				Else
                    RemoveHandler bitmapImage1.ImageOpened, value
				End If
			End Set
		End Property

		Private privateIsImageOpened As Boolean
		Public Property IsImageOpened As Boolean
			Get
				Return privateIsImageOpened
			End Get
			Protected Set(ByVal value As Boolean)
				privateIsImageOpened = value
			End Set
		End Property

        Public Property Scale As Double
            Set(ByVal value As Double)

                scale1.ScaleX = value
                scale1.ScaleY = value              
            End Set
            Get
                Return Scale1.ScaleX
            End Get
        End Property

		Public Sub Refresh()
			Me.IsImageOpened = False
            bitmapImage1.UriSource = Me.QuadKey.ToUri()
		End Sub

		Private Sub OnBitmapImageOpened(ByVal sender As Object, ByVal args As RoutedEventArgs)
			Me.IsImageOpened = True

			' Not detaching this handler leads to an out-of-memory problem
            RemoveHandler bitmapImage1.ImageOpened, AddressOf OnBitmapImageOpened
		End Sub
	End Class
End Namespace
