﻿Imports System.Text
Imports Microsoft.VisualBasic

Namespace OrientingMap
	Public Class QuadKey
'INSTANT VB NOTE: The variable value was renamed since Visual Basic does not allow class members with the same name:
        Private value_1 As Long = Long.MinValue
'INSTANT VB NOTE: The variable longitude was renamed since Visual Basic does not allow class members with the same name:
        Private longitude_1 As Integer = Integer.MinValue
'INSTANT VB NOTE: The variable latitude was renamed since Visual Basic does not allow class members with the same name:
        Private latitude_1 As Integer = Integer.MinValue
'INSTANT VB NOTE: The variable parent was renamed since Visual Basic does not allow class members with the same name:
        Private parent_1 As QuadKey
        Private siblings_1() As QuadKey
        Private children_1() As QuadKey
		Private strValue As String

		Public Sub New(ByVal value As Long, ByVal level As Integer)
            Me.value_1 = value
			Me.Level = level
		End Sub

		Public Sub New(ByVal longitude As Integer, ByVal latitude As Integer, ByVal level As Integer)
            Me.longitude_1 = longitude
            Me.latitude_1 = latitude
			Me.Level = level
		End Sub

		Public Shared Property UriTemplate As String

		Public ReadOnly Property Value As Long
			Get
                If Me.value_1 = Long.MinValue Then
                    Me.value_1 = 0
                    Dim mask As Integer = 1 << (Me.Level - 1)

                    For i As Integer = 0 To Me.Level - 1
                        value_1 <<= 2

                        If (Me.longitude_1 And mask) <> 0 Then
                            Me.value_1 = Me.value_1 Or 1
                        End If

                        If (Me.latitude_1 And mask) <> 0 Then
                            Me.value_1 = Me.value_1 Or 2
                        End If

                        mask >>= 1
                    Next i
                End If
                Return Me.value_1
			End Get
		End Property

		Public ReadOnly Property Longitude As Integer
			Get
                If Me.longitude_1 = Integer.MinValue Then
                    CalculateLongitudeLatitudeFromQuadKey()
                End If
                Return Me.longitude_1
			End Get
		End Property

		Public ReadOnly Property Latitude As Integer
			Get
                If Me.latitude_1 = Integer.MinValue Then
                    CalculateLongitudeLatitudeFromQuadKey()
                End If
                Return Me.latitude_1
			End Get
		End Property

		Private privateLevel As Integer
		Public Property Level As Integer
			Get
				Return privateLevel
			End Get
            Private Set(ByVal value2 As Integer)
                privateLevel = value2
            End Set
		End Property

		Public ReadOnly Property Quadrant As Integer
			Get
                Return CInt(Me.Value And 3)
			End Get
		End Property

		Public ReadOnly Property Parent As QuadKey
			Get
                If Me.parent_1 Is Nothing Then
                    Me.parent_1 = New QuadKey(Me.Value >> 2, Me.Level - 1)
                End If
                Return Me.parent_1
			End Get
		End Property

		' Not used
		Public ReadOnly Property Siblings As QuadKey()
			Get
                If Me.siblings_1 Is Nothing Then
                    Me.siblings_1 = New QuadKey(3) {}
                    Dim quadKey0 As Long = Me.Value And Not 3

                    For i As Integer = 0 To 3
                        Me.siblings_1(i) = New QuadKey(quadKey0 Or i, Me.Level)
                    Next i
                End If
                Return Me.siblings_1
			End Get
		End Property

		Public ReadOnly Property Children As QuadKey()
			Get
                If Me.children_1 Is Nothing Then
                    Me.children_1 = New QuadKey(3) {}
                    Dim quadKey0 As Long = Me.Value << 2

                    For i As Integer = 0 To 3
                        Me.children_1(i) = New QuadKey(quadKey0 Or i, Me.Level + 1)
                    Next i
                End If
                Return Me.children_1
			End Get
		End Property

		Public Function GetQuadKeyFromRowColumnOffsets(ByVal col As Integer, ByVal row As Integer) As QuadKey
			Dim maxValue As Integer = (1 << Me.Level) - 1

			If Me.Longitude + col < 0 OrElse Me.Longitude + col > maxValue OrElse Me.Latitude + row < 0 OrElse Me.Latitude + row > maxValue Then
				Return Nothing
			End If

			Return New QuadKey(Me.Longitude + col, Me.Latitude + row, Me.Level)
		End Function

		Private Sub CalculateLongitudeLatitudeFromQuadKey()
            Me.longitude_1 = 0
            Me.latitude_1 = 0
			Dim mask As Long = 1L << (2 * Me.Level - 1)

			For i As Integer = 0 To Me.Level - 1
                Me.longitude_1 <<= 1
                Me.latitude_1 <<= 1

                If (Me.value_1 And mask) <> 0 Then
                    Me.latitude_1 = Me.latitude_1 Or 1
                End If

				mask >>= 1

                If (Me.value_1 And mask) <> 0 Then
                    Me.longitude_1 = Me.longitude_1 Or 1
                End If

				mask >>= 1
			Next i
		End Sub

		Public Function ToUri() As Uri
			Return New Uri(UriTemplate.Replace("{quadkey}", Me.ToString()))
		End Function

		Public Overloads Function Equals(ByVal that As QuadKey) As Boolean
			Return Me.Value = that.Value AndAlso Me.Level = that.Level
		End Function

		Public Overrides Overloads Function Equals(ByVal obj As Object) As Boolean
			If Not(TypeOf obj Is QuadKey) Then
				Return False
			End If

			Return Equals(TryCast(obj, QuadKey))
		End Function

		Public Overrides Function GetHashCode() As Integer
            Return CInt(Me.Value)
		End Function

		Public Overrides Function ToString() As String
			If strValue Is Nothing Then
				Dim strBuilder As New StringBuilder
				Dim quadKey As Long = Me.Value

				For i As Integer = 0 To Me.Level - 1
					strBuilder.Insert(0, (quadKey And 3).ToString())
					quadKey >>= 2
				Next i
				strValue = strBuilder.ToString()
			End If
			Return strValue
		End Function

    End Class
End Namespace
